//LIBRERIAS
#include <TM1637Display.h>
#include <Timer.h>
#include <Wire.h>
#include "RTClib.h"
#include <Keypad.h>
#include <Servo.h>

//TM1637
#define CLK 2
#define DIO 3

uint8_t data[] = {0xff, 0xff, 0xff, 0xff};
uint8_t blank[] = {0x00, 0x00, 0x00, 0x00};
uint8_t blank1[] = {0xff, 0x00, 0x00, 0x00};
uint8_t blank2[] = {0xff, 0xff, 0x00, 0x00};
uint8_t blank3[] = {0xff, 0xff, 0xff, 0x00};
uint8_t blank4[] = {0xff, 0xff, 0xff, 0xff};

TM1637Display display (CLK, DIO);


int minX0, min0X, secX0, sec0X = 0;
double timer = 0.00000;
int hour, minute = 0;
bool colon = true;
Timer t;



// SIMBOLO ALARMA
const uint8_t ala[] = {
  SEG_A | SEG_B | SEG_C | SEG_E | SEG_F | SEG_G,  // A
  SEG_D | SEG_E | SEG_F,                                  // L
  SEG_A | SEG_B | SEG_C | SEG_E | SEG_F | SEG_G,  // A
  SEG_F | SEG_B | SEG_D  ,                                 // CARITA | SMILY FACE
};

//SIMBOLO ARRIBA
const uint8_t UP[] = {
  0x00,
  SEG_F | SEG_E | SEG_D | SEG_B | SEG_C , // U
  SEG_A | SEG_B | SEG_E | SEG_F | SEG_G,  // P
  0x00,
};

//KEYPAD
const byte rowsCount = 4;
const byte columsCount = 4;

char keys[rowsCount][columsCount] = {
  { ' ', '1', '2', '3'  },
  { ' ', '4', '5', '6'  },
  { ' ', '7', '8', '9'  },
  { ' ', ' ', '0', }
};

const byte rowPins[rowsCount] = { 13, 12, 11, 10 };
const byte columnPins[columsCount] = {9, 8, 7, 6};

Keypad keypad = Keypad(makeKeymap(keys), rowPins, columnPins, rowsCount, columsCount);


int alarma = A0; //REFLEXIVO | REFLEXIVE
int parar;
int seg1, min1, hor1, ano1, mes1, dia1;
int min2, hor2, hor3, min3 ;
int minala1, horala1, horala2, minala2 , minala3, horala3;
int i;
int z;
int y;
int x;
int q;
int pulsacion0;
int pulsacion1;
int pulsacion2;
int pulsacion3;
int alarmahor, alarmamin;
int led3 = 18;
int led = 16;
int BUZZER = 5;
const int pulsadorAlarma = 4;
const int pulsadorPin = 22;
int valorPulsador = 1;
int valoralarma = 1;
Servo mano;

RTC_DS3231 rtc;



void setup() {
  mano.attach(24 );
  display.setBrightness(0); //BRILLO AL MINIMO | LOWEST BRIGHTNESS

  Serial.begin (9600);
  pinMode(pulsadorPin, INPUT_PULLUP);
  pinMode(alarma, INPUT);
  pinMode(pulsadorAlarma, INPUT_PULLUP);
  pinMode(led, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(BUZZER, OUTPUT);
  if (!rtc.begin()) {
    Serial.println(F("Couldn't find RTC"));
    while (1);
  }

  if (rtc.lostPower()) {
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  }

}



void loop() {
  DateTime now = rtc.now();
  hor1 = now.hour();
  min1 = now.minute();
  mano.write(180);
  if (hor1 < 10) {  // SI LA HORA ES MENOR A 10
    hor2 = 0;       // SU PRIMERA CIFRA ES CERO
    hor3 = hor1;    // SU SEGUNDA CIFRA ES LA HORA
  }
  if (hor1 >= 10 && hor1 < 20) { // SI LA HORA ESTA ENTRE LAS 10 Y LAS 19
    hor2 = 1;                    // SU PRIMERA CIFRA ES 1
    hor3 = hor1 - 10;            // SU SEGUNDA CIFRA ES LA HORA MENOS 10
  }
  if (hor1 >= 20 && hor1 < 25) { // SI LA HORA ESTA ENTRE LAS 20 Y LAS 24
    hor2 = 2;                    // SU PRIMERA CIFRA ES 2
    hor3 = hor1 - 20;            // SU SEGUNDA CIFRA ES LA HORA MENOS 20
  }


  if (min1 < 10) {              // SI LOS MINUTOS SON MENORES DE 10
    min2 = 0;                   // SU PRIMERA CIFRA ES 0
    min3 = min1;                // SU SEGUNDA CIFRA SON LOS MINUTOS
  }
  if (min1 >= 10 && min1 < 20 ) { // SI LOS MINUTOS ESTAN ENTRE 10 Y 19
    min2 = 1;                     // SU PRIMERA CIFRA ES 1
    min3 = min1 - 10;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 10
  }
  if (min1 >= 20 && min1 < 30 ) { // SI LOS MINUTOS ESTAN ENTRE 20 Y 29
    min2 = 2;                     // SU PRIMERA CIFRA ES 2
    min3 = min1 - 20;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 20
  }
  if (min1 >= 30 && min1 < 40 ) {// SI LOS MINUTOS ESTAN ENTRE 30 Y 39
    min2 = 3;                    // SU PRIMERA CIFRA ES 3
    min3 = min1 - 30;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 30
  }
  if (min1 >= 40 && min1 < 50 ) {// SI LOS MINUTOS ESTAN ENTRE 40 Y 49
    min2 = 4;                    // SU PRIMERA CIFRA ES 4
    min3 = min1 - 40;            // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 40
  }
  if (min1 >= 50 && min1 < 60 ) {// SI LOS MINUTOS ESTAN ENTRE 50 Y 59
    min2 = 5;                    // SU PRIMERA CIFRA ES 5
    min3 = min1 - 50;            // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 50
  }


  char key = keypad.getKey();
  valoralarma = digitalRead(pulsadorAlarma);
  valorPulsador = digitalRead(pulsadorPin);


  if ( valoralarma == HIGH ) { // SI EL BOTON NO ESTA PULSADO
    digitalWrite(led, LOW);    // LED OFF
    digitalWrite(led3, LOW);   // LED OFF
    noTone(BUZZER);            //NO SONIDO
    mano.write(180);             // SERVO POSICION INCIAL

    if (hor2 == 0) { //SI EL PRIMER DIGITO ES CERO
      if (hor3 == 0 && hor2 == 0) {   //SI SON LAS DOCE DE LA NOCHE
        data[0] = display.encodeDigit(0);
        data[1] = display.encodeDigit(0);   // MOSTRAR EL CERO
        data[2] = display.encodeDigit(min2);
        data[3] = display.encodeDigit(min3);
        display.setSegments(data);
      }
      else {
        data[0] = display.encodeDigit(0);     // MOSTRAR EL CERO
        data[1] = display.encodeDigit(hor3);
        data[2] = display.encodeDigit(min2);
        data[3] = display.encodeDigit(min3);
        display.setSegments(data);

      }

    }
    else {  // SI NO SON LAS DOCE DE LA NOCHE
      data[0] = display.encodeDigit(hor2);   // MOSTRAR LA HORA
      data[1] = display.encodeDigit(hor3);
      data[2] = display.encodeDigit(min2);
      data[3] = display.encodeDigit(min3);
      display.setSegments(data);
    }
  }
  else {  // SI EL BOTON ESTA PULSADO
    display.setSegments(ala);  // ENSEÑAR EN EL TM1637 SIMBOLO ALARMA
    delay(500);
    for (i = 0; i < 1; i++) { // PRIMERA PULSACION ES IGUAL A LA PRIMERA CIFRA DE LA HORA DE LA ALARMA
      char pulsacion0;
      pulsacion0 = keypad.waitForKey();
      horala1 = pulsacion0 - 48 ;
      blank1[0] = display.encodeDigit(horala1);
      Serial.println(pulsacion0);
      Serial.println(horala1);
      display.setSegments(blank1);
    }

    for (z = 1; z < 2; z++) { // SEGUNDA PULSACION ES IGUAL A LA SEGUNDA CIFRA DE LA HORA DE LA ALARMA
      char pulsacion1;
      pulsacion1 = keypad.waitForKey();
      horala2 = pulsacion1 - 48;
      blank2[0] = display.encodeDigit(horala1);
      blank2[1] = display.encodeDigit(horala2);
      display.setSegments(blank2);
    }
    for (y = 2; y < 3; y++) { // PRIMERA PULSACION ES IGUAL A LA PRIMERA CIFRA DE LOS MINUTOS DE LA ALARMA
      char pulsacion2;
      pulsacion2 = keypad.waitForKey();
      minala1 = pulsacion2 - 48;
      blank3[0] = display.encodeDigit(horala1);
      blank3[1] = display.encodeDigit(horala2);
      blank3[2] = display.encodeDigit(minala1);
      display.setSegments(blank3);
    }
    for (x = 3; x < 4; x++) { // PRIMERA PULSACION ES IGUAL A LA SEGUNDA CIFRA DE LOS MINUTOS DE LA ALARMA
      char pulsacion3;
      pulsacion3 = keypad.waitForKey();
      minala2 = pulsacion3 - 48;
      blank4[0] = display.encodeDigit(horala1);
      blank4[1] = display.encodeDigit(horala2);
      blank4[2] = display.encodeDigit(minala1);
      blank4[3] = display.encodeDigit(minala2);
      display.setSegments(blank4);
    }
    delay(2000);
    minala3 = (minala1 * 10 + minala2 ); // LOS MINUTOS ES IGUAL A LA 3 PULSACION *10 MAS LA 4 PULSACION
    horala3 = (horala1 * 10 + horala2);  // LOS HORA ES IGUAL A LA 1 PULSACION *10 MAS LA 2 PULSACION

    while (min1 != minala3 || hor1 != horala3) { // MIENTRAS QUE LA ALARMA SEA DIFERENTE A LA HORA REAL
      if (digitalRead(pulsadorPin) == LOW) {  // SI EL BOTON2 ESTA PULSADO

        if (horala1 == 0) {
          mano.write(180);
          blank4[0] = display.encodeDigit(0);
          blank4[1] = display.encodeDigit(horala2);
          blank4[2] = display.encodeDigit(minala1);
          blank4[3] = display.encodeDigit(minala2);
          display.setSegments(blank4);
          delay(20);
        }
        else {
          mano.write(180);             // SERVO POSICION INCIAL
          display.showNumberDec(horala1 * 1000 + horala2 * 100 +  minala1 * 10 +  minala2);  // MOSTRAR ALARMA EN EL TM1637
          delay(20);
        }

        delay(20);

      }
      else {  // MIENTRAS NO ESTE PULSADO EL BOTON2
        DateTime now = rtc.now();
        hor1 = now.hour();
        min1 = now.minute();
        mano.write(180);
        if (hor1 < 10) {  // SI LA HORA ES MENOR A 10
          hor2 = 0;       // SU PRIMERA CIFRA ES CERO
          hor3 = hor1;    // SU SEGUNDA CIFRA ES LA HORA
        }
        if (hor1 >= 10 && hor1 < 20) { // SI LA HORA ESTA ENTRE LAS 10 Y LAS 19
          hor2 = 1;                    // SU PRIMERA CIFRA ES 1
          hor3 = hor1 - 10;            // SU SEGUNDA CIFRA ES LA HORA MENOS 10
        }
        if (hor1 >= 20 && hor1 < 25) { // SI LA HORA ESTA ENTRE LAS 20 Y LAS 24
          hor2 = 2;                    // SU PRIMERA CIFRA ES 2
          hor3 = hor1 - 20;            // SU SEGUNDA CIFRA ES LA HORA MENOS 20
        }


        if (min1 < 10) {              // SI LOS MINUTOS SON MENORES DE 10
          min2 = 0;                   // SU PRIMERA CIFRA ES 0
          min3 = min1;                // SU SEGUNDA CIFRA SON LOS MINUTOS
        }
        if (min1 >= 10 && min1 < 20 ) { // SI LOS MINUTOS ESTAN ENTRE 10 Y 19
          min2 = 1;                     // SU PRIMERA CIFRA ES 1
          min3 = min1 - 10;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 10
        }
        if (min1 >= 20 && min1 < 30 ) { // SI LOS MINUTOS ESTAN ENTRE 20 Y 29
          min2 = 2;                     // SU PRIMERA CIFRA ES 2
          min3 = min1 - 20;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 20
        }
        if (min1 >= 30 && min1 < 40 ) {// SI LOS MINUTOS ESTAN ENTRE 30 Y 39
          min2 = 3;                    // SU PRIMERA CIFRA ES 3
          min3 = min1 - 30;             // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 30
        }
        if (min1 >= 40 && min1 < 50 ) {// SI LOS MINUTOS ESTAN ENTRE 40 Y 49
          min2 = 4;                    // SU PRIMERA CIFRA ES 4
          min3 = min1 - 40;            // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 40
        }
        if (min1 >= 50 && min1 < 60 ) {// SI LOS MINUTOS ESTAN ENTRE 50 Y 59
          min2 = 5;                    // SU PRIMERA CIFRA ES 5
          min3 = min1 - 50;            // SU SEGUNDA CIFRA ES LOS MINUTOS MENOS 50
        }

        if (hor2 == 0) { //SI EL PRIMER DIGITO ES CERO



          if (hor3 == 0 && hor2 == 0) {   //SI SON LAS DOCE DE LA NOCHE

            data[0] = display.encodeDigit(0);
            data[1] = display.encodeDigit(0);   // MOSTRAR EL CERO
            data[2] = display.encodeDigit(min2);
            data[3] = display.encodeDigit(min3);
            display.setSegments(data);
            delay(1000);
          }
          else {

            data[0] = display.encodeDigit(0);     // MOSTRAR EL CERO
            data[1] = display.encodeDigit(hor3);
            data[2] = display.encodeDigit(min2);
            data[3] = display.encodeDigit(min3);
            display.setSegments(data);
            delay(1000);
          }
        }

        else {  // SI NO SON LAS DOCE DE LA NOCHE

          display.showNumberDec(hor1 * 100 + min1);
          delay(1000);
        }



      }
    }
    // CUANDO SEAN IGUALES LA HORA Y LA ALARMA
    while (analogRead(alarma) > 100) { // MIENTRAS QUE EL REFLEXIVO SEA MAYOR DE 100 (NO ESTE PULSADO)
      display.clear();                 // MOSTRAR EN EL TM1637 SIMBOLO "UP" PARPADEANDO
      tone(BUZZER, 900);               // SONIDO 900
      digitalWrite(led, LOW);          //APAGA LED
      digitalWrite(led3, LOW);         // APAGA LED
      mano.write(0);                   //SERVO 0
      delay(700);
      tone(BUZZER, 100);               // SONIDO 100
      digitalWrite(led, HIGH);        // LED ON
      digitalWrite(led3, HIGH);       // LED ON
      display.setSegments(UP);        // MOSTRAR EN EL TM1637 SIMBOLO "UP" PARPADEANDO
      mano.write(180);                // SERVO 180
      delay(700);
    }

    delay(100);
  }

}
